'''
Script modified from code written by Qixin He at the University of Michigan (present address: University of Chicago), posted with permission.
'''


#change output .par to empirical settings
import os
dir = os.getcwd() + "/Splatche_dataset" #need to change
infile=file(dir + "/PopMap.txt")
infile.readline()
samp2pop={}
popSeqDict={}
for line in infile:
	popn,ind=line.split()
	samp2pop[ind]=popn
	if not popn in popSeqDict:
		popSeqDict[popn]=['',0]
infile.close()
popList = popSeqDict.keys()
popList.sort()
arpfile=file(dir + "/GeneticsOutput/Splatche_settings_quchry-temp_GeneSamples_oak_1.arp")
flag=0
for line in arpfile:
	if len(line)>1 and not line.startswith("#"):
		if "SampleName=" in line:
			sample = line.strip().replace('"','').replace('SampleName=','')
			flag = 1
			continue
		if flag == 1:
			if "SampleSize=" in line:
				popSeqDict[samp2pop[sample]][1] += int(line.strip().replace('SampleSize=',''))
				continue
			elif "SampleData= {" in line:
				flag=2
				continue
		if flag==2:
			if "}" in line:
				flag = 0
			else:
				popSeqDict[samp2pop[sample]][0] += line
	if "[[Structure]]" in line:
		break

prof = '''#Arlequin input from splatche2
[Profile]

		Title="sumstat on simulated data"
		NbSamples=%d
	  GenotypicData=1
	  GameticPhase=0
	  RecessiveData=0
	  DataType=MICROSAT
	  LocusSeparator=TAB
	  MissingData='?'

[Data]
	
	[[Samples]]
%s
	[[Structure]]

		StructureName="lerista"
		NbGroups=1

		Group={
%s
		}
'''
sampleDummy = '''		SampleName="%s"
		SampleSize=%d
		SampleData= {
%s
}

'''

sampleout=''
groupName = ''
for popl in popList:
	groupName += '     "%s"\n'%popl
	sampleout+=sampleDummy %(popl,popSeqDict[popl][1],popSeqDict[popl][0])

outfile=open("quchry_genesamples_modified-temp.arp","w") #you can change the output name
outfile.write(prof%(len(popList),sampleout,groupName))
outfile.close()